#include <stdio.h>
#include <stdlib.h>

typedef struct{
 double kaal;
 double pikkus;
 double tulu;
 int matr;
} struktuur;

int Nlugemine(FILE *andmed) //See funktsioon vtab andmete failist N vrtuse ning kontrollib, kas see vastab tingimusele
{
 int N;
 fscanf(andmed, "%d", &N);
 if(N <= 45)
 return N;
}
void keskmised(int N, struktuur M[N], double kesk_pikkus_tulu[1])//Selle funktsiooniga leian keskmise pikkuse ning keskmise tulu ning paigutan nad massiivi
{
	int i;
	double keskpik=0, kesktulu=0;
	for(i=0; i<N; i++)
	{
		keskpik = keskpik + M[i].pikkus;
		kesktulu = kesktulu + M[i].tulu;
	}
	kesk_pikkus_tulu[0] = keskpik / N;
	kesk_pikkus_tulu[1] = kesktulu / N;
	printf("Keskmine pikkus: %.3f\nKeskmine tulu: %.3f\n", kesk_pikkus_tulu[0], kesk_pikkus_tulu[1]);
}

void isikuandmed(FILE *andmed, int N, struktuur M[N])//for tsklit kasutades saan isikute kaalu, pikkuse, tulu ja matrikli numbri massiivi M
{
    int i;
	for(i=0;i<N;i++)
	{
		fscanf(andmed, "%lf", &M[i].kaal);
		fscanf(andmed, "%lf", &M[i].pikkus);
		fscanf(andmed, "%lf", &M[i].tulu);
		fscanf(andmed, "%d", &M[i].matr);
		
		printf("Isik number %d\nKaal: %.3lf ", i, M[i].kaal);
		printf("Pikkus: %.3lf ", M[i].pikkus);
		printf("Tulu: %.3lf ", M[i].tulu);
		printf("Matrikkel: %d\n\n", M[i].matr);
	}
}

void ting_vastavalt_valjastus(double kesk_pikkus_tulu[2], int N, struktuur M[N], FILE *tulemus)//Funktsioon kontrollib for tsklis 2 isikuandme tingimust ning prindib ekraanile ja faili tingimustele vastavad kirjed
{
	printf("Tingimustele vastavad inimesed:\n\nKaal\tPikkus\tTulu\tMatrikkel\n");
	fprintf(tulemus, "Tingimustele vastavad inimesed:\n\nKaal\tPikkus\tTulu\tMatrikkel\n");
	int i;
	for(i=0; i<N; i++)
	{
		if(M[i].pikkus < kesk_pikkus_tulu[0] && M[i].tulu > kesk_pikkus_tulu[1])
		{
			printf("%.1f\t%.1f\t%.1f\t%d\n", M[i].kaal, M[i].pikkus, M[i].tulu, M[i].matr);
			fprintf(tulemus, "%.1f\t%.1f\t%.1f\t%d\n", M[i].kaal, M[i].pikkus, M[i].tulu, M[i].matr);
		}
	}
}

int main(void)
{
    char andmeFail[]="siss.txt";   
    char tulemusteFail[]="valja.txt";
    FILE *andmed, *tulemus;
    andmed = fopen(andmeFail,"r"); //Siiani toimub andmete faili deklareerimine ning andmete faili avamine

	double kesk_pikkus_tulu[1];
	int N = Nlugemine(andmed); //Prdumine Nlugemine juurde, et saada vrtuse N
	struktuur M[N];//Vajaliku struktuuri deklareerimine suurusega N
	if(N > 0)
	printf("Massiivi pikkus on: %d\n", N);
	else				//Kontrollin, et N poleks vale vrtusega
	{
		printf("Paranda andmete faili! N on lubatud olla 1'st kuni 45'ni!\n");
		exit(0);
	}
	
	isikuandmed(andmed, N, M); //Saan failist isikute andmed
	fclose(andmed);//Sulen andmete faili, sest seda pole enam vaja
	
	keskmised(N, M, kesk_pikkus_tulu);//Prdun funktsiooni poole, et leida keskmise pikkuse ja keskmise tulu
	
    tulemus=fopen(tulemusteFail, "w");//avan tulemustefaili, et sinna saaks kirjutada andmeid
	ting_vastavalt_valjastus(kesk_pikkus_tulu, N, M, tulemus);//funktsioon vljastab tingimustele vastavate isikute andmed
	
    fclose(tulemus);//Tulemuste faili sulgemine
    return 0;
}
